Index: palm/trunk/SOURCE/calc_mean_profile.f90
===================================================================
--- palm/trunk/SOURCE/calc_mean_profile.f90	(revision 2693)
+++ palm/trunk/SOURCE/calc_mean_profile.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file calc_mean_profile.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Enable usage also during initialization, required for initialization of 
+! radiation and land-surface model (MS)
+! 
+! 2233 2017-05-30 18:08:54Z suehring
 !
 ! 2232 2017-05-30 17:47:52Z suehring
@@ -109,7 +113,9 @@
 !--    is done only for the first respective intermediate timestep in order to
 !--    spare communication time and to produce identical model results with jobs
-!--    which are calling flow_statistics at different time intervals.
+!--    which are calling flow_statistics at different time intervals. At 
+!--    initialization, intermediate_timestep_count = 0 is considered as well.
+
        IF ( .NOT. flow_statistics_called  .AND.                                &
-            intermediate_timestep_count == 1 )  THEN
+            intermediate_timestep_count <= 1 )  THEN
 
 !
Index: palm/trunk/SOURCE/calc_radiation.f90
===================================================================
--- palm/trunk/SOURCE/calc_radiation.f90	(revision 2693)
+++ palm/trunk/SOURCE/calc_radiation.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file calc_radiation.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/check_for_restart.f90
===================================================================
--- palm/trunk/SOURCE/check_for_restart.f90	(revision 2693)
+++ palm/trunk/SOURCE/check_for_restart.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file check_for_restart.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 2693)
+++ palm/trunk/SOURCE/check_open.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file check_open.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -12,5 +12,5 @@
 ! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 !
-! You should have received a copy of the GNU fGeneral Public License along with
+! You should have received a copy of the GNU General Public License along with
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 2693)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file check_parameters.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! Implementation of uv exposure model (FK)
+! + new possible value for dissipation_1d
+! Added checks for turbulence_closure_mod (TG)
+! Implementation of chemistry module (FK)
+! 
+! 2689 2017-12-12 17:46:55Z Giersch
 ! Bugfix in if query
 ! 
@@ -552,4 +558,10 @@
 
     USE arrays_3d
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_boundary_conds, chem_check_data_output,                    &
+               chem_check_data_output_pr, chem_species                 
+    USE chem_modules
+#endif
     USE cloud_parameters
     USE constants
@@ -570,4 +582,8 @@
     USE model_1d_mod,                                                          &
         ONLY:  damp_level_1d, damp_level_ind_1d
+
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  init_model, input_pids_static, netcdf_data_input_check_dynamic, &
+               netcdf_data_input_check_static
 
     USE netcdf_interface,                                                      &
@@ -596,6 +612,10 @@
         ONLY:  stg_check_parameters
     USE transpose_indices
+    USE turbulence_closure_mod,                                                &
+        ONLY:  tcm_check_data_output, tcm_check_parameters
     USE urban_surface_mod,                                                     &
         ONLY:  usm_check_data_output, usm_check_parameters
+    USE uv_exposure_model_mod,                                                 &
+        ONLY:  uvem_check_data_output
     USE wind_turbine_model_mod,                                                &
         ONLY:  wtm_check_parameters
@@ -623,4 +643,5 @@
     INTEGER(iwp) ::  netcdf_data_format_save         !<
     INTEGER(iwp) ::  position                        !<
+    INTEGER(iwp) ::  lsp                             !< running index for chem spcs.
 
     LOGICAL     ::  found                            !<
@@ -633,5 +654,8 @@
 
     CALL location_message( 'checking parameters', .FALSE. )
-
+!
+!-- At first, check static and dynamic input for consistency
+    CALL netcdf_data_input_check_dynamic
+    CALL netcdf_data_input_check_static
 !
 !-- Check for overlap combinations, which are not realized yet
@@ -673,4 +697,5 @@
 #if defined( __parallel )
 
+
        IF ( myid == 0 ) THEN
           CALL MPI_SEND( dt_coupling, 1, MPI_REAL, target_id, 11, comm_inter,  &
@@ -849,4 +874,5 @@
        CALL message( 'check_parameters', 'PA0001', 1, 2, 0, 6, 0 )
     ENDIF
+
 
 !
@@ -936,4 +962,8 @@
 
     ENDIF
+
+!
+!-- Check turbulence closure setup
+    CALL tcm_check_parameters
 
 !
@@ -1092,4 +1122,5 @@
        CALL message( 'check_parameters', 'PA0469', 1, 2, 0, 6, 0 )
     ENDIF
+
 !
 !-- Check whether there are any illegal values
@@ -1244,5 +1275,6 @@
 
              CASE ( 'set_constant_profiles', 'set_1d-model_profiles',          &
-                    'by_user', 'initialize_vortex', 'initialize_ptanom' )
+                    'by_user', 'initialize_vortex', 'initialize_ptanom',       &
+                    'inifor' )
                 action = action(position+1:)
 
@@ -1347,5 +1379,11 @@
        IF ( ocean          )  sa_init = sa_surface
        IF ( passive_scalar )  s_init  = s_surface
-
+#if defined(__chem )                              
+       IF ( air_chemistry )  THEN
+         DO lsp = 1, nvar
+            chem_species(lsp)%conc_pr_init = cs_surface(lsp)      
+         ENDDO
+       ENDIF
+#endif 
 !
 !--
@@ -1558,4 +1596,18 @@
        ENDIF
 !
+!--    Compute initial chemistry profile using the given chemical species gradients
+#if defined( __chem )
+       IF ( air_chemistry )  THEN                                                          
+         DO lsp = 1, nvar
+          CALL init_vertical_profiles( cs_vertical_gradient_level_ind(lsp,:),  &
+                                       cs_vertical_gradient_level(lsp,:),      &
+                                       cs_vertical_gradient(lsp,:),            &
+                                       chem_species(lsp)%conc_pr_init,         &
+                                       cs_surface(lsp), bc_cs_t_val(lsp) )
+         ENDDO
+       ENDIF
+#endif
+!
+!
 !--    If required, compute initial salinity profile using the given salinity
 !--    gradients
@@ -1610,5 +1662,11 @@
 
 !
-!-- Compute Coriolis parameter
+!-- Overwrite latitude if necessary and compute Coriolis parameter. 
+!-- To do - move initialization of f and fs to coriolis_mod.
+    IF ( input_pids_static )  THEN
+       latitude  = init_model%latitude
+       longitude = init_model%longitude
+    ENDIF
+
     f  = 2.0_wp * omega * SIN( latitude / 180.0_wp * pi )
     fs = 2.0_wp * omega * COS( latitude / 180.0_wp * pi )
@@ -1799,5 +1857,6 @@
        ibc_p_t = 0
 !-- TO_DO: later set bc_p_t to neumann before, in case of nested domain
-    ELSEIF ( bc_p_t == 'neumann' .OR. bc_p_t == 'nested' )  THEN
+    ELSEIF ( bc_p_t == 'neumann' .OR. bc_p_t == 'nested'  .OR.                 &
+             bc_p_t == 'forcing'  )  THEN
        ibc_p_t = 1
     ELSE
@@ -1829,5 +1888,5 @@
     ELSEIF ( bc_pt_t == 'initial_gradient' )  THEN
        ibc_pt_t = 2
-    ELSEIF ( bc_pt_t == 'nested' )  THEN
+    ELSEIF ( bc_pt_t == 'nested'  .OR.  bc_pt_t == 'forcing' )  THEN
        ibc_pt_t = 3
     ELSE
@@ -2029,4 +2088,11 @@
        ENDIF
     ENDIF
+
+!
+!-- Boundary conditions for chemical species
+#if defined( __chem )
+    IF ( air_chemistry )  CALL chem_boundary_conds( 'init' )
+#endif
+
 !
 !-- Boundary conditions for horizontal components of wind speed
@@ -2068,5 +2134,5 @@
        ELSEIF ( bc_uv_t == 'neumann' )  THEN
           ibc_uv_t = 1
-       ELSEIF ( bc_uv_t == 'nested' )  THEN
+       ELSEIF ( bc_uv_t == 'nested'  .OR.  bc_uv_t == 'forcing' )  THEN
           ibc_uv_t = 3
        ELSE
@@ -2982,4 +3048,11 @@
              ENDIF
 
+#if defined( __chem )
+             IF ( unit == 'illegal' )  THEN                                        
+                CALL chem_check_data_output_pr( data_output_pr(i), i,          &
+                                                unit, dopr_unit(i) )
+             ENDIF 
+#endif
+
              IF ( unit == 'illegal' )  THEN
                 unit = ''
@@ -3261,9 +3334,22 @@
           CASE DEFAULT
 
-             CALL lsm_check_data_output ( var, unit, i, ilen, k )
+             CALL tcm_check_data_output ( var, unit, i, ilen, k )
+
+             IF ( unit == 'illegal' )  THEN
+                CALL lsm_check_data_output ( var, unit, i, ilen, k )
+             ENDIF
 
              IF ( unit == 'illegal' )  THEN
                 CALL radiation_check_data_output( var, unit, i, ilen, k )
              ENDIF
+
+!
+!--          Block of chemistry model outputs
+#if defined( __chem )
+             IF ( unit == 'illegal'  .AND.  air_chemistry                      &
+                                     .AND.  var(1:3) == 'kc_' )  THEN
+                CALL chem_check_data_output( var, unit, i, ilen, k )
+             ENDIF
+#endif
 
 !
@@ -3277,4 +3363,10 @@
              IF ( unit == 'illegal' .AND. plant_canopy .AND. var(1:4) == 'pcm_' ) THEN
                  CALL pcm_check_data_output( var, unit )
+             ENDIF
+
+!
+!--          Block of uv exposure model outputs
+             IF ( unit == 'illegal' .AND. uv_exposure .AND. var(1:5) == 'uvem_' )  THEN
+                CALL uvem_check_data_output( var, unit, i, ilen, k )
              ENDIF
 
@@ -3669,5 +3761,5 @@
           dist_nxl    = MAX( inflow_disturbance_begin, nxl )
           dist_nxr(1) = MIN( inflow_disturbance_end, nxr )
-       ELSEIF ( bc_lr == 'nested' )  THEN
+       ELSEIF ( bc_lr == 'nested'  .OR.  bc_lr == 'forcing' )  THEN
           dist_nxl = MAX( inflow_disturbance_begin, nxl )
        ENDIF
@@ -3678,5 +3770,5 @@
           dist_nys    = MAX( inflow_disturbance_begin, nys )
           dist_nyn(1) = MIN( inflow_disturbance_end, nyn )
-       ELSEIF ( bc_ns == 'nested' )  THEN
+       ELSEIF ( bc_ns == 'nested'  .OR.  bc_ns == 'forcing' )  THEN
           dist_nys = MAX( inflow_disturbance_begin, nys )
        ENDIF
@@ -3790,5 +3882,6 @@
     ENDIF
     IF ( TRIM( dissipation_1d ) /= 'as_in_3d_model'  .AND.                     &
-         TRIM( dissipation_1d ) /= 'detering' )  THEN
+         TRIM( dissipation_1d ) /= 'detering'  .AND.                           &
+         TRIM( dissipation_1d ) /= 'prognostic' )  THEN
        message_string = 'dissipation_1d = "' // TRIM( dissipation_1d ) //      &
                         '" is unknown'
@@ -4130,5 +4223,5 @@
        ELSEIF ( bc_t == 'initial_gradient' )  THEN
           ibc_t = 2
-       ELSEIF ( bc_t == 'nested' )  THEN
+       ELSEIF ( bc_t == 'nested'  .OR.  bc_t == 'forcing' )  THEN
           ibc_t = 3
        ELSE
Index: palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- palm/trunk/SOURCE/chem_modules.f90	(revision 2696)
+++ palm/trunk/SOURCE/chem_modules.f90	(revision 2696)
@@ -0,0 +1,132 @@
+!> @file chem_modules.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2017 Leibniz Universitaet Hannover
+! Copyright 2017-2017 Karlsruhe Institute of Technology
+! Copyright 2017-2017 Freie Universitaet Berlin
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+!
+! Authors:
+! --------
+! @author Farah Kanani-Suehring
+! @author Basit Khan
+!
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Definition of global palm-4u chemistry variables
+!> (Module written to define global palm-4u chemistry variables. basit 16Nov2017)
+!------------------------------------------------------------------------------!
+!
+ MODULE chem_modules
+#if defined( __chem )  
+    USE kinds 
+    USE chem_gasphase_mod,                                                     &   
+        ONLY: nspec, nvar, spc_names
+
+
+    IMPLICIT NONE
+
+    PUBLIC nspec
+    PUBLIC nvar
+    PUBLIC spc_names
+
+    LOGICAL ::  constant_top_csflux(99)            = .TRUE.                       !< chem spcs at the top  orig .TRUE.
+    LOGICAL ::  constant_csflux(99)                = .TRUE.                       !< chem spcs at namelist parameter   orig TRUE
+
+
+    INTEGER(iwp) :: cs_vertical_gradient_level_ind(99,10) = -9999                 !< grid index values of cs_vertical_gradient_level_ind(s)
+    REAL(wp),     DIMENSION(:),   ALLOCATABLE :: bc_cs_t_val
+    INTEGER(iwp)                              :: ibc_cs_b                         !< integer flag for bc_cs_b
+    INTEGER(iwp)                              :: ibc_cs_t                         !< integer flag for bc_cs_t
+
+    REAL(wp),      DIMENSION(:),  ALLOCATABLE ::  css                             !< scaling parameter for chem spcs
+
+!-- Namelist parameters for creating initial chemistry profiles
+    CHARACTER (LEN=20)               :: bc_cs_b    = 'dirichlet'                  !< namelist parameter
+    CHARACTER (LEN=20)               :: bc_cs_t    = 'initial_gradient'           !< namelist parameter
+    REAL(wp) :: wall_csflux (99,0:5)               = 0.0_wp                       !< namelist parameter
+    REAL(wp) :: cs_vertical_gradient (99,10)       = 0.0_wp                       !< namelist parameter
+    REAL(wp) :: cs_vertical_gradient_level (99,10) = -999999.9_wp                 !< namelist parameter
+    REAL(wp) :: top_csflux ( 99 )                  = 0.0_wp                       !< namelist parameter 
+    REAL(wp) :: cs_surface_initial_change(99)      = 0.0_wp                       !< namelist parameter
+    REAL(wp) :: surface_csflux(99 )                = 0.0_wp                       !< namelist parameter: fluxes where 'surface_csflux_name' is in the namelist
+!   RFo: I do not know whether it makes sense to have 'constant_csflux=.TRUE. for only these species where 
+!        no flux is given in the namelist. Let's choos surface_csflux=0.0 (and thus 'constant_csflux'=.TRUE.) as default
+!       To obtain  constant_csflux=.FALSE., set surface_csflux = 9999999.9 in the namelist
+!   @todo: need to think a bit more about constant_csflux for chemistry. 
+
+    LOGICAL :: call_chem_at_all_substeps           = .FALSE.                      !< namelist parameter 
+    LOGICAL :: chem_debug0                         = .FALSE.                      !< namelist parameter flag for minimum print output
+    LOGICAL :: chem_debug1                         = .FALSE.                      !< namelist parameter flag for print output
+    LOGICAL :: chem_debug2                         = .FALSE.                      !< namelist parameter flag for further print output
+    LOGICAL :: chem_gasphase_on                    = .TRUE.                       !< namelist parameter 
+
+    CHARACTER (LEN=11), DIMENSION(99)         :: cs_name = 'novalue'              !< Namelist parameter: chem spcs names 
+    CHARACTER (LEN=11), DIMENSION(99)         :: cs_profile_name = 'novalue'      !< Namelist parameter: Names of the
+    CHARACTER (LEN=11), DIMENSION(99)         :: surface_csflux_name = 'novalue'  !< Namelist parameter: chem species surface fluxes names
+                                                                                  !< active chem spcs, default is 'novalue')  ????
+    REAL(wp), DIMENSION(99)                   :: cs_surface = 0.0_wp              !< Namelist parameter: Surface conc of chem spcs'
+    REAL(wp), DIMENSION(99,100)               :: cs_heights = 9999999.9_wp        !< Namelist parameter: Height lvls(m) for cs_profiles
+    REAL(wp), DIMENSION(99,100)               :: cs_profile = 9999999.9_wp        !< Namelist parameter: Chem conc for each spcs defined
+
+#if defined( __nopointer )
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: cs                       !< chem spcs
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: cs_p                     !< prognostic value of chem spc
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: tcs_m                    !< weighted tendency of s for previous sub-timestep (Runge-Kutta)
+
+#else                                                               
+! use pointers cs, cs_p and tcs_m to point arrays cs_1, cs_2, and cs_3
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_1                     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_2                     !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_3                     !< pointer for swapping of timelevels for respective quantity
+
+    REAL(wp), DIMENSION(:,:,:), POINTER               :: cs                       !< pointer: sgs chem spcs)
+    REAL(wp), DIMENSION(:,:,:), POINTER               :: cs_p                     !< pointer: prognostic value of sgs chem spcs 
+    REAL(wp), DIMENSION(:,:,:), POINTER               :: tcs_m                    !< pointer:
+
+#endif                                                                            
+                                                                                  !< by cs_name for each height lvls defined by cs_heights
+!
+!-- Namelist parameters for chem_emissions
+    INTEGER(iwp) ::  main_street_id = 0
+    INTEGER(iwp) ::  max_street_id = 0
+    INTEGER(iwp) ::  side_street_id = 0
+!
+!-- Constant emission factors
+    REAL(wp) ::  emiss_factor_main = 0.0_wp
+    REAL(wp) ::  emiss_factor_side = 0.0_wp
+    
+!-- Emission factors with daily cycle
+!     REAL(wp), DIMENSION(1:24) ::  emiss_factor_main = 0.0_wp
+!     REAL(wp), DIMENSION(1:24) ::  emiss_factor_side = 0.0_wp
+
+    SAVE
+#endif
+ END MODULE chem_modules
+
